#!/usr/bin/php-cgi
<?php
	include("topinsert.php");
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
	<title><?php echo $dTitle; ?></title>
	<link rel="stylesheet" type="text/css" href="<?php echo $GLOBALS['vendorsPath']; ?>vendors/bootstrap/css/bootstrap.min.css">
	<link rel="stylesheet" type="text/css" href="<?php echo $GLOBALS['vendorsPath']; ?>vendors/fontawesome/css/font-awesome.min.css">
    <?php include $GLOBALS['assetsPath']."css/style.php"; ?>
    <!-- <meta name="viewport" content="width=device-width, initial-scale=1"> -->
	<meta name='viewport' content='content="width=device-width, maximum-scale=1.0, minimum-scale=1.0, initial-scale=1.0' />
    
<?php include "funcjs.php"; ?>
</head>
<body>
		<div id="wrapper" style="background-color:#E8E9EA">
			<!-- wrapper -->

			<!-- Sidebar -->
			<?php include('sidebar.php'); ?>
        <!-- /#sidebar-wrapper -->

        <div id="page-content-wrapper">
				<!-- Header -->
				<nav>
					<ul class="navigation">
						<li class="nav-open">
							<a href="" id="sidemenu-open"><span class="glyphicon glyphicon-menu-hamburger"></span></a>
						</li>
						<li  class="nav-title">
							Leave Vessel
						</li>
						<li  class="nav-search">
							<a href="" id="search-open"><span class="glyphicon glyphicon-search"></span></a>
						</li>
					</ul>
				</nav>
				<!-- Header -->
				
				<div class="clearfix"></div>
				<!-- COntent/container -->
				<div class="row-fluid">
					<div class="search-container">
						<input>
					</div>
					<div class="js-auto-height">
						<div class="usercontrol-edit-profile" style="padding:20px">
                        	<form name="msgtyper" id="vlrds">
                            <p id="lblmsger1" style="font-size:14px" onClick="leaveradio('auto')"><input type="radio" checked id="msger1" name="msger" value="msgtype1" style="vertical-align: middle; margin: 0px;" onClick="leaveradio('auto')">&nbsp;<strong>Autoreply Message</strong></p>
                            <p id="lblmsger2" style="font-size:14px" onClick="leaveradio('manual')"><input type="radio" id="msger2" name="msger" value="msgtype2" style="vertical-align: middle; margin: 0px;" onClick="leaveradio('manual')">&nbsp;<strong>Forward my messages to this email address</strong></p>
                            
                            <div id="autoreplydiv">
                            <p id="vldisp" style="display:100%">Please type your autoreply message. The system shall send this message to anyone sending a message to you after your account has been deactivated.</p>
                            <textarea id="txtVl" maxlength="160" style="width:100%"></textarea>
                            </div>
                            
                            <div align="center" style="width:100%; padding-top:15px">
                            <a href="javascript:;" onClick="leavenow();" class="cbtn cbtn-orange">Leave</a>
                            </div>
                            </form>            
                            <div class="input-group" style="height:110px">
								&nbsp;
							</div>

						</div>
							
					</div>
					<div class="clearfix"></div>
				</div>
				<!-- COntent/container -->

			</div><!--#page content wrapper -->
		</div><!--#Wrapper -->

<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>vendors/jquery/jquery.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>vendors/jquery/jquery.mobile.custom.min.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>vendors/bootstrap/js/bootstrap.min.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>vendors/cropbox.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>js/main.js"></script>
<script type="text/javascript" src="<?php echo $GLOBALS['vendorsPath']; ?>js/nav.js"></script>

<?php include "loading.php"; ?>
<script>
$(document).ready(function () {
	$("#unameUCP").keypress(function (e) {
		var regex = new RegExp("^[a-zA-Z0-9 /\b//\t//\r//\v//\e/]+$");
		var str = String.fromCharCode(!e.charCode ? e.which : e.charCode);
		if (regex.test(str)) {
			return true;
		}
		
		e.preventDefault();
		return false;
	});
});

var msgtypervl = "";

function leaveradio(x){
	if(x=='auto'){
		document.getElementById('msger1').checked=true;
		document.getElementById('vldisp').innerHTML="Please type your autoreply message. The system shall send this message to anyone sending a message to you after your account has been deactivated.";
		document.getElementById('txtVl').innerHTML="";
		document.getElementById('txtVl').style.height="100px";
		
	}
	else if(x=='manual'){
		document.getElementById('msger2').checked=true;
		document.getElementById('vldisp').innerHTML="Please type a valid and existing email address. After deactivation of your account, we shall forward all your incoming messages to your given email address for the next 90 days or until you have reactivated your account, whichever comes first.";
		document.getElementById('txtVl').innerHTML="";
		document.getElementById('txtVl').style.height="60px";
		
	}
	msgtypervl = x;
}

function leavenow(){
	if (document.getElementById('txtVl').value.length == 0) {
		if (msgtypervl=='manual') {showMessageAlert('Please enter an Email Address.');} else {showMessageAlert('Please enter a message.');}
		return;
	} else if (msgtypervl=='manual') {
		var reg = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
	
		if (reg.test(document.getElementById('txtVl').value) == false) 
		{
			showMessageAlert('You have entered an Invalid Email Address');
			return;
		}
	}
	
	showLoadingMessageDisp("Leaving vessel... please wait.");
	
	var noerror = true;
	//var dhost = host + 'api/rest/unregisteruser';
	var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/rest/unregisteruser';
	
	var requestapi;
	requestapi = $.ajax({
		url: dhost,
		type: "post",
		data: { loginid: '<?php echo ((isset($_SESSION['uid']) && strlen(isset($_SESSION['uid'])) > 0)?$_SESSION['uid']:""); ?>', signoffmessage: document.getElementById('txtVl').value<?php echo urladdparams(); ?>+""+getSession()},
		timeout: 30000
	});
	
	requestapi.done(function (response, textStatus, jqXHR){
		if (noerror) {
			
			try {
				var stat = false;
				$.each(response, function(index, val) {
					if ((index.toUpperCase() == "STATUS") && (val.toUpperCase() == "SUCCESS")) {
						stat = true;
					}
				});
			} catch (e) {
				stat = false;
			}
				
			if (stat) {
				showLoadingMessageDisp("Logging off... Please wait.");
				
				/*showMessageAlert("Thank you for using <?php echo $dTitle; ?>.\nYou may reactivate your account by registering into the system using your Login ID and Password.");
				
				<?php
				/*if (isset($GLOBALS['ISDESKTOP']) && $GLOBALS['ISDESKTOP'] == "1") {
					echo 'location.href = "../m/serv.php?act=0&dir=d";';
				} else {
					echo 'location.href = "serv.php?act=0&dir=m";';
				}*/
				?>
				//location.href = "serv.php?act=0&dir=m";*/
				
				try {
					sweetAlert({
							title: "Thank you for using <?php echo $dTitle; ?>.\nYou may reactivate your account by registering into the system using your Login ID and Password.",
							showCancelButton: false,
							confirmButtonText: "Ok",
							closeOnConfirm: true 
						},
						function(isConfirm){
							<?php
							if (isset($GLOBALS['ISDESKTOP']) && $GLOBALS['ISDESKTOP'] == "1") {
								echo 'location.href = "../m/serv.php?act=0&dir=d";';
							} else {
								echo 'location.href = "serv.php?act=0&dir=m";';
							}
							?>
						}
					);
				} catch (e) {
					alert("Thank you for using <?php echo $dTitle; ?>.\nYou may reactivate your account by registering into the system using your Login ID and Password.");
					<?php
					if (isset($GLOBALS['ISDESKTOP']) && $GLOBALS['ISDESKTOP'] == "1") {
						echo 'location.href = "../m/serv.php?act=0&dir=d";';
					} else {
						echo 'location.href = "serv.php?act=0&dir=m";';
					}
					?>
				}
			} else {
				showMessageAlert('There was an error in logging off, please try again later.');
				hideLoadingMessageDispIfDone();
			}
		}
	});

	requestapi.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		if (textStatus=="timeout") {
			//alert('The request timed out. Please try again.');
		} else {
			//alert('An error has occurred. Please try again.');
		}
		
		showMessageAlert('An error has occurred. Please try again.');
		hideLoadingMessageDispIfDone();
	});

	requestapi.always(function () {
		requestapi = null;
	});
}

leaveradio('auto');
</script>
</body>
</html>
<?php include "foot.php"; ?>