<?php
	/*$rmt = "0";
	if (isset($_GET['rmt'])) {
		$rmt = stripslashes($_GET['rmt']);
	}*/$rmt = "0";
	
	if ($isProd) {
		$GLOBALS['versionConf'] = "/www/vesconf.txt";
		$GLOBALS['localStorage'] = "/www/localstore/";
	} else {
		$GLOBALS['versionConf'] = "../../mailparser/production/serverfiles/vesconf.txt";
		$GLOBALS['localStorage'] = "../localstore/";
	}
	
	function getVesselVersionForDailyCheck() {
		$iniFile = $GLOBALS['versionConf'];
		if (is_file($iniFile)) {
			//Do nothing... File already exists
		} else {
			//Try to create
			$fh = fopen($iniFile, 'w+');
			fclose($fh);
		}
		$filecontent = file_get_contents($iniFile);
		//PARSE FILE!!!
		$filecontent = explode("[DSEP]", $filecontent);
		
		if (date("Ymd") > $filecontent[0]) { //Refetch once daily as per Wilfred 2016-08-30
			$sserv = "";
		} else if ($filecontent[0] > date("Ymd")) { //Force refetch if date today is less than last check
			$sserv = "";
		} else {
			$sserv = $filecontent[1];
		}
		
		return $sserv;
	}
	
	function getLocalFileData($fname) {
		$filecontent = "";
		$iniFile = $GLOBALS['localStorage'] . $fname;
		if (is_file($iniFile)) {
			//Do nothing... File already exists
			$filecontent = file_get_contents($iniFile);
		} else {
			//Try to create
			/*$fh = fopen($iniFile, 'w+');
			fclose($fh);*/
		}
		
		return $filecontent;
	}
	
	function loopThruNewsDirAndDeleteOld($days) {
		$retainDate = date('Ymd', strtotime('-' . $days . ' days', strtotime(date('Y-m-d'))));
		
		$path = $GLOBALS['localStorage'];
		
		if ($handle = opendir($path)) {
			while (false !== ($file = readdir($handle))) {
				if ('.' === $file) continue;
				if ('..' === $file) continue;
				if ('1' === $file) continue;
		
				if (is_dir($path . "/" . $file)) {
					if ((int)$retainDate >= (int)$file) {
						//echo "Cleaning " . $file . " folder...<BR>";
						deleteFilesInDir($path . "/" . $file);
						
						if (rmdir($path . "/" . $file)) {
							/*echo "Folder " . $file . " deleted.<BR><BR>";
						} else {
							echo "Cannot delete folder " . $file . "<BR><BR>";*/
						}
					}	
				}
			}
			closedir($handle);
		}
	}
	
	function deleteFilesInDir($path) {
		if ($handle = opendir($path)) {
			while (false !== ($file = readdir($handle))) {
				if ('.' === $file) continue;
				if ('..' === $file) continue;
		
				if (unlink($path . "/" . $file)) {
					/*echo "File " . $file . " deleted.<BR>";
				} else {
					echo "Cannot delete file " . $file . "<BR>";*/
				}
			}
			closedir($handle);
		}
	}
	
	//TEMPORARY UNTIL FLEET NEWS IS CHANGED TO DAILY
	function loopThruFleetDir() {
		$path = $GLOBALS['localStorage'];
		
		if ($handle = opendir($path)) {
			while (false !== ($file = readdir($handle))) {
				if ('.' === $file) continue;
				if ('..' === $file) continue;
		
				if (is_dir($path . "/" . $file) && ($file === "1")) {
					deleteFilesInDir($path . "/" . $file);
					rmdir($path . "/" . $file);
				}
			}
			closedir($handle);
		}
	}
	//TEMPORARY UNTIL FLEET NEWS IS CHANGED TO DAILY
	
	function doCleanUp($msg) {
		$msg = str_replace("[", "", $msg);
		$msg = str_replace("{", "", $msg);
		$msg = str_replace("}", "", $msg);
		$msg = str_replace("]", "", $msg);
		$msg = str_replace("]", "", $msg);
		$msg = str_replace('"', '', $msg);
		
		if (strlen($msg) > 0) {} else {
			//REMOVE OLD NEWS ITEMS
			$reqName = base64_encode("getVesselSettings");
			$response = getLocalFileData($reqName);
			
			if (strlen($response) > 0) {
				$response = base64_decode($response);
				$responseJSON = json_decode($response, true);
				$VesselNewsDaysRetain = ((is_array($responseJSON['VesselNewsDaysRetain']))?"30":$responseJSON['VesselNewsDaysRetain']);
				$VesselFleetDaysRetain = ((is_array($responseJSON['VesselFleetDaysRetain']))?"30":$responseJSON['VesselFleetDaysRetain']);
				if (strlen($VesselNewsDaysRetain) == 0) {$VesselNewsDaysRetain = "30";}
				if (strlen($VesselFleetDaysRetain) == 0) {$VesselFleetDaysRetain = "30";}
				
				if (is_numeric($VesselNewsDaysRetain) && ((int)$VesselNewsDaysRetain > 0)) {
					loopThruNewsDirAndDeleteOld($VesselNewsDaysRetain);
				}
				
				if (is_numeric($VesselFleetDaysRetain) && ((int)$VesselFleetDaysRetain > 0)) {
					
				}
			}
			//REMOVE OLD NEWS ITEMS
			
			unlink( $GLOBALS['localStorage'] . base64_encode("getVesselSettings") );
			unlink( $GLOBALS['localStorage'] . base64_encode("getVesselConfig") );
			unlink( $GLOBALS['localStorage'] . "1/" . base64_encode("LNews1") );
			
			//TEMPORARY UNTIL FLEET NEWS IS CHANGED TO DAILY
			loopThruFleetDir();
			//TEMPORARY UNTIL FLEET NEWS IS CHANGED TO DAILY
		}
	}
	
	$rmt = "0";
	if (isset($_GET['rmt'])) {
		$rmt = stripslashes($_GET['rmt']);
	} else {
		if (strlen(getVesselVersionForDailyCheck()) == 0) {
			$rmt = "1";
			
			doCleanUp();
		}
	}
?>
<script language="javascript">
console.log('<?php echo "RMT: ". $rmt; ?>');

var requestReboot = false;
var didARequestReboot = false;

var lclFW = new Array();
var lclCP = new Array();
var rmFW = new Array();
var rmCP = new Array();
var rmFWFL = "";
var rmCPFL = "";
var lclFWFL;
var isRemoteUpdating = false;

var lclWAN;
var rmWAN;
var arrForwards = [];

function submitLogin() {
	if (isRemoteUpdating) {
		showMessageAlert('The client has received an update from the server and is applying changes, please wait.');
		return;
	}
	
	var uid = $("#duserid").val();
	var upas = $("#duserpass").val()
	if (uid.length != 6) {
		$("#duserid").focus();
		return;
	} else if (upas.length != 6) {
		$("#duserpass").focus();
		return;
	}
	
	<?php
	if ($isself == "portal.php") {
		echo "jqVESSEL_REGSTATUS = '" . $GLOBALS['arr_vesver']['vessel_regstatus'] . "'";
	}
	?>

	if ((jqVESSEL_REGSTATUS == 1) || (jqVESSEL_REGSTATUS == "1")) {
		//Check userid, numeric
		if (/*isAllNumbers*/ validateSMSEmail(uid) && uid.length == 6) {
			showLoadingMessageDisp("Logging in... Please wait.");
			validateLogin(uid, upas);
			//hideLoadingMessageDispIfDone();

			document.getElementById("duserid").value = "";
			document.getElementById("duserpass").value = "";
		} else {
			showMessageAlert('Please check userid and password.');
		}
	} else {
		if (errorInetConnection) {
			/*showMessageAlert('Connection error, please try again.');

			showLoadingMessageDisp("Reloading... Please wait.");
			reloadHeadlinesUnread = setInterval(function () {
				refetchHeadlinesNUnread();
			}, 100);*/
			
			sweetAlert({
					title: "Connection Error",
					text: "Error in fetching the vessel settings.\nClick 'OK' to retry.",
					showCancelButton: true,
					confirmButtonText: "OK",
					cancelButtonText: "Cancel",
					closeOnConfirm: true,
					closeOnCancel: true 
				},
				function(isConfirm){
					if (isConfirm) {
						showLoadingMessageDisp("Reloading... Please wait.");
						clearInterval( reloadHeadlinesUnread );
						reloadHeadlinesUnread = setInterval(function () {
							refetchHeadlinesNUnread();
						}, 100);
					}
				}
			);
		} else {
			/*if ((jqVESSEL_REGSTATUS == 0) || (jqVESSEL_REGSTATUS == "0")) {
				showMessageAlert('Vessel not activated.');
			} else if ((jqVESSEL_REGSTATUS == 2) || (jqVESSEL_REGSTATUS == "2")) {
				showMessageAlert('Vessel has expired.');
			} else {
				showMessageAlert('Vessel not activated.');
			}*/
			
			/*
			1 - Production
			2 - Expired
			4 - Production Duplicate
			7 - Production Inactive
			5 - Archive
			6 - Invalid
			*/
			if ((jqVESSEL_REGSTATUS == 0) || (jqVESSEL_REGSTATUS == "0")) {
				showMessageAlert('Vessel not activated.');
			} else if ((jqVESSEL_REGSTATUS == 2) || (jqVESSEL_REGSTATUS == "2")) {
				showMessageAlert('Vessel trial has expired.');
			} else if ((jqVESSEL_REGSTATUS == 5) || (jqVESSEL_REGSTATUS == "5")) {
				showMessageAlert('Vessel has been deactivated.');
			} else if ((jqVESSEL_REGSTATUS == 6) || (jqVESSEL_REGSTATUS == "6")) {
				showMessageAlert('Vessel is invalid.');
			} else {
				showMessageAlert('Vessel not activated.');
			}
		}
	}
}

var tmpuid; var tmpupas;

function validateLogin(uid, upas) {
	var noerror = true;
    //var dhost = host + 'api/rest/login';
	var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/rest/login';

	var regstat = '0';
	var username = '0';

	var requestapi;
	requestapi = $.ajax({
		url: dhost,
		type: "post",
		data: {macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>', loginid: uid, password: upas, vesselid: jqVESSEL_VESSELID<?php echo urladdparams(); ?>+""+getSession()},
		timeout: 30000
	});

	ajxCnt++;

	requestapi.done(function (response, textStatus, jqXHR){
		if (noerror) {

			ajxCnt++;

			try {

				$.each(response, function (index, value) {
					try {

						switch(index.toUpperCase()) {
							case "REGSTATUS":
								regstat = value;
								break;
							case "USERNAME":
								username = value;
								break;
						}

					} catch (e) {}

				});

			} catch (e) {}

			if (regstat.length == 0) {regstat = "2";}
			if ((regstat == 0) || (regstat == "0")) {regstat = "2";}

			switch (regstat) {
				case "1":
					ajxCnt++;ajxCnt++;ajxCnt++;
					logUserToServer(uid, upas);
					break;
				case "2":
					tmpuid = uid;
					tmpupas = upas;
					document.getElementById("to_reg_username").value = "";
					document.getElementById("to_reg_userid").value = uid;
					document.getElementById("useridnotregistered").style.display = "block";
					document.getElementById("to_reg_username").focus();
					break;
				case "3":
					/*<?php if ($isself == "portal.php") { ?>
					ajxCnt++;ajxCnt++;ajxCnt++;
					logUserToServer(uid, upas);
					<?php } else { ?>
					showMessageAlert('Your registration is being processed. Try again later.');
					document.getElementById("duserid").focus();
					<?php } ?>*/ //REMOVED 2017-07-31
					
					showMessageAlert('Your registration is being processed. Try again later.');
					document.getElementById("duserid").focus();
					break;
				case "4":
					showMessageAlert('Your registration is being processed.\nPlease contact support for further assistance.');
					document.getElementById("duserid").focus();
					break;
				case "5":
					showMessageAlert('Your login id ' + uid + ' is currently disabled.\nPlease contact support for further assistance.');
					document.getElementById("duserid").focus();
					break;
				default:
					showMessageAlert("Problem logging in. Please try again.");
					document.getElementById("duserid").focus();
			}

			if (regstat == "1") {} else {
				ajxCnt--;
				hideLoadingMessageDispIfDone();
			}
			<?php if ($isself == "portal.php") { ?>
			/*if ((regstat == "1") || (regstat == "3")) {} else {
				ajxCnt--;
				hideLoadingMessageDispIfDone();
			}*/ //Removed 2018-01-31
			<?php } ?>
		}
	});

	requestapi.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;

		var invalidlogin = false;
		try {
			$.each(jqXHR, function (index, value) {
				if ((index == "responseText") && ( value.toLowerCase().indexOf("invalid loginid or password") >= 0)) {
					invalidlogin = true;
				}
				
				if (index == "responseJSON") {
					$.each(value, function (index1, value1) {
						if ( value1.toLowerCase().indexOf("invalid loginid or password") >= 0 ) {
							invalidlogin = true;
						}
					});
				}
			});
		} catch (e) {}
		if (invalidlogin) {
			showMessageAlert('Invalid loginid or password. Please try again.');
		} else {
			showMessageAlert('Connection error. Please try again.');
		}

		ajxCnt--;
		hideLoadingMessageDispIfDone();
	});

	requestapi.always(function () {
		requestapi = null;

		ajxCnt--;
		hideLoadingMessageDispIfDone();
	});
}

function registerUser() {
	if (/[^a-zA-Z0-9 ]/.test( document.getElementById('to_reg_username').value )) {
		showMessageAlert('Only letters, numbers and space are allowed for the username.');
		return;
	}

	showLoadingMessageDisp("Registering... Please wait.");

	var noerror = true;
    //var dhost = host + 'api/rest/registeruser';
	var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/rest/registeruser';

	var regstat = "";
	var uid = document.getElementById("to_reg_userid").value;
	var uname = document.getElementById("to_reg_username").value;

	var requestapi;
	requestapi = $.ajax({
		url: dhost,
		type: "post",
		data: {macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>', loginid: uid, username: uname<?php echo urladdparams(); ?>+""+getSession()},
		timeout: 30000
	});

	ajxCnt++;

	requestapi.done(function (response, textStatus, jqXHR){
		if (noerror) {

			ajxCnt++;

			try {

				$.each(response, function (index, value) {

					try {

						switch(index.toUpperCase()) {
							case "STATUS":
								regstat = value;
								break;
						}

					} catch (e) {}

				});

			} catch (e) {}

			ajxCnt--;
			hideLoadingMessageDispIfDone();

			if (regstat == "Success") {
				<?php //if ($isself == "portal.php") { ?> //Removed 2018-01-31
				//ajxCnt++;ajxCnt++;ajxCnt++;
				//logUserToServer(tmpuid, tmpupas);
				<?php //} else { ?>
				document.getElementById("to_reg_username").value = "";
				document.getElementById("to_reg_userid").value = "";
				document.getElementById("useridnotregistered").style.display = "none";
				document.getElementById("duserid").focus();
				showMessageAlert('Your registration is being processed. You may login again after 10 minutes.');
			    //showMessageAlert('Your registration is being processed. You may try to use the system again after the next Server message synchronization.');
				<?php //} ?>
			} else {
				showMessageAlert('Registration error has occured, please try again.' + regstat);
			}
		}
	});

	requestapi.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;

		showMessageAlert('Registration error has occured, please try again.');
	});

	requestapi.always(function () {
		requestapi = null;

		ajxCnt--;
		hideLoadingMessageDispIfDone();
	});
}

function logUserToServer(uid,upass) {
	var noerror = true;
	<?php
	if (isset($GLOBALS['ISDESKTOP']) && $GLOBALS['ISDESKTOP'] == "1") {
		echo "var dhost = '../m/serv.php';";
	} else {
		echo "var dhost = 'serv.php';";
	}
	?>
	//var addDeskParam = '<?php //echo (isset($GLOBALS['ISDESKTOP']) && ($GLOBALS['ISDESKTOP'] == "1"))?"../m/":"" ?>';
    //var dhost = addDeskParam + 'serv.php';

	var requestapi;
	requestapi = $.ajax({
		url: dhost,
		type: "post",
		data: {act: '1', uid: uid, upass: upass<?php echo urladdparams(); ?>+""+getSession()},
		timeout: 30000
	});

	requestapi.done(function (response, textStatus, jqXHR){
		if (noerror) {

			response = response.replace("#!/usr/bin/php-cgi", "");
			response = myTrim(response);
			
			<?php
			if ($isself == "portal.php") {
				echo 'if (response == "landing.php") {response = "dashboard.php";}';
			}
			?>
			
			$(window).unbind('beforeunload');
			document.location.href = response;

		}
	});

	requestapi.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;

		ajxCnt = 0;
		hideLoadingMessageDispIfDone();
	});

	requestapi.always(function () {
		requestapi = null;

		//ajxCnt--;
		//hideLoadingMessageDispIfDone();
	});
}

function getUserUnread(ddata) {
	var noerror = true;
    //var dhost = host + 'api/rest/getticker';
	//var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/rest/getticker';
	//var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/rest/getticker2';
	
	var ssip = checkServerConnection();
	var dhost = linksysHost + "?csipadd="+ssip+"&act=getticker2";
	var tckrcnt = 0;

    var requestapi;
	requestapi = $.ajax({
		url: dhost,
		type: "post",
		data: ddata, //{ macid: intermacid }
		timeout: 30000
	});

	//ajxCnt++;

	$('ul.unread-messages').empty();
	$('ul.unread-messages').html('');
	/*$('ul.unread-messages').append(
		'<li style="text-align:center; width:100%;"><span class="unread-messages__title">Requesting unread messages</span></li>'
	);*/
	$('ul.unread-messages').html('<li style="text-align:center; width:100%;"><span class="unread-messages__title">Requesting unread messages</span></li>');

	requestapi.done(function (response, textStatus, jqXHR){
		//getUserUnreadCheckTime();
		
		if (noerror) {

			//ajxCnt++;

			try {

				var uname = "";
				var ucnt = 0;
				var unreadMessageTemplate ='';
				var counter = 1;
				<?php if (isset($GLOBALS['ISDESKTOP']) && $GLOBALS['ISDESKTOP'] == "1"):?>
					var fill = 24;
				<?php else:?>
					var fill = 12;
				<?php endif;?>
				

				$('ul.unread-messages').empty();
				$('ul.unread-messages').html('');

					
				$.each(response, function (index, value) {

					if(counter == 1){
						unreadMessageTemplate += '<div class="item active">';
						unreadMessageTemplate += '<ul class="unread-messages">';
					}

					uname = "";
					ucnt = 0;

					try {

						$.each(value, function (dindex, dvalue) {
							if ((dvalue == 'null') || (dvalue == null) || (dvalue.length == 0) || (dvalue.toLowerCase() == 'undefined')) {dvalue = "&nbsp;";}

							if (dvalue == '&nbsp;') {dvalue = "";}
							try {
								switch(dindex.toUpperCase()) {
									case "USERNAME":
										uname = dvalue;
										break;
									case "CTRINBOX":
										ucnt = dvalue;
										break;
								}
							} catch(e) {}
						});

						tckrcnt++;
					} catch (e) {}


					
					
					//if ((ucnt.length > 0) || (ucnt > 0)) 
					if ((ucnt.length > 0) && (parseInt(ucnt) > 0)) 
					{
						unreadMessageTemplate += '<li><span class="unread-messages__count">(' + ucnt + ')</span><span class="unread-messages__title">&nbsp;' + uname + '</span></li>';
					}

					if(counter == fill){
						unreadMessageTemplate += '</ul>';
						unreadMessageTemplate += '</div>';
						unreadMessageTemplate += '<div class="item">';
						unreadMessageTemplate += '<ul class="unread-messages">';
						counter = 1;
					}
					
					counter++;
				});


				$('#unreadmessagescarouselinner').html(unreadMessageTemplate);

			} catch (e) {}

			if (tckrcnt == 0) {
				$('ul.unread-messages').empty();
				$('ul.unread-messages').html('');
				$('ul.unread-messages').html(
					'<li style="text-align:center; width:100%;"><span class="unread-messages__title">No unread messages</span></li>'
				);
			}

			//ajxCnt--;
			//hideLoadingMessageDispIfDone();
		}
	});

	requestapi.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		$('ul.unread-messages').empty();
		$('ul.unread-messages').html('');
		$('ul.unread-messages').html(
			'<li style="text-align:center; width:100%;"><span class="unread-messages__title">No unread messages</span></li>'
		);
	});

	requestapi.always(function () {
		requestapi = null;

		//ajxCnt--;
		//hideLoadingMessageDispIfDone();
		
		getUserUnreadCheckTime();
	});
}

var tickerTime = 0; var tickerDisplayTimer;
function getUserUnreadCheckTime() {
	var noerror = true; clearInterval( tickerDisplayTimer );
    
	var ssip = checkServerConnection();
	var dhost = linksysHost + "?act=2";
	var tckrcnt = 0;

    var requestapi;
	requestapi = $.ajax({
		url: dhost,
		type: "get",
		timeout: 30000
	});

	requestapi.done(function (response, textStatus, jqXHR){
		if (noerror) {
			tickerTime = response;
			document.getElementById("last_update").innerHTML =  '<i class="fa fa-clock-o"></i>&nbsp;<span id="last_update_time" class="last_update_time"><i>Last Ticker Update: ' + humanTiming(parseInt(response)) + '</i></span>';
			
			tickerDisplayTimer = setInterval(function () {
				tickerTime = parseInt(tickerTime) + 1;
				updateTickerTime (tickerTime);
			}, 1000);
		}
	});

	requestapi.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestapi.always(function () {
		requestapi = null;
	});
}

function updateTickerTime(response) {
	document.getElementById("last_update").innerHTML =  '<i class="fa fa-clock-o"></i>&nbsp;<span id="last_update_time" class="last_update_time"><i>Last Ticker Update: ' + humanTiming(parseInt(response)) + '</i></span>';
}

function humanTiming (time) {
			
	var tokens ={
		'year': 31536000,
		'month': 2592000,
		'week': 604800,
		'day': 86400,
		'hour': 3600,
		'minute': 60,
		'second': 1
	};
	
	var timeTxt = "second"; var timeVal = time; var found = false;
	$.each(tokens, function(index, val) {
		if ((time >= parseInt(val)) && (found == false)) {
			found = true;
			timeTxt = index;
			timeVal = Math.floor(time / parseInt(val));
		}
	});
	
	/*if ((timeTxt == "minute") && (timeVal >= 31)) {
		clearInterval( tickerDisplayTimer );
		getUserUnreadCheckTime();
	}*/
	
	if (timeVal > 1) {timeTxt = timeTxt + "s";}
	return timeVal + " " + timeTxt + " ago";

}

function getLoginHeadlines(newsdate) {
	$("#headloadinglinesholder").show();
	$("#headlinesholder").hide();
	$("#headlinescarousel").carousel("pause").removeData();

	//Check if current news items are in local storage
	var storedResponse;
	if (newsdate == '1') {} else {storedResponse = getLocalStorage('LNews' + newsdate);}
	if ((typeof storedResponse === 'object') && (storedResponse !== null)) {
		processLoginNews(storedResponse);
	} else {

		//Request fleet announcements first
		var noerror = true;
		//var dhost = host + 'api/rest/requestnews';
		//var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/rest/requestnews';
		
		var ssip = checkServerConnection();
		var dhost = linksysHost + "?csipadd="+ssip+"&act=getLoginHeadlines";

		var requestapi;
		requestapi = $.ajax({
			url: dhost,
			type: "post",
			data: {
				macid: '<?php echo $GLOBALS['MACID']; ?>',
				api_key: '<?php echo $GLOBALS['APIKEY']; ?>',
				newsfname: 'LNews' + newsdate,
				newsdate: newsdate,
				<?php
				if (isset($GLOBALS['ISDESKTOP']) && $GLOBALS['ISDESKTOP'] == "1") {
					echo 'newslogin: "1",';
				} else {
					echo 'newslogin: "2",';
				}
				?>
				//newslogin: "2",
				newsid: "",
				newsheader: "1",
				newscountry: "",
				newscategory: ""<?php echo urladdparams(); ?>+""+getSession()
			},
			timeout: 30000
		});

		//ajxCnt++;

		requestapi.done(function (response, textStatus, jqXHR){
			if (noerror) {

				//ajxCnt++;

				//if ((typeof response === 'object') && (response !== null)) {
					setLocalStorage('LNews' + newsdate, response);
				//}

				processLoginNews(response);

			}
		});

		requestapi.fail(function (jqXHR, textStatus, errorThrown){
			noerror = false;

			//$("#headlinelbl").text('No headlines available.');
			$("#headlinelbl").text('No headlines');
		});

		requestapi.always(function () {
			requestapi = null;

			//ajxCnt--;
			//hideLoadingMessageDispIfDone();
		});
		//Request fleet announcements first

	}
}

function processLoginNews(response) {
	var newscnt = 0;
	

	try {

		var dtitle = "";
		var dbody = "";
		var isFleet = false;

		$.each(response, function (index, value) {
			dtitle = "";
			dbody = "";
			isFleet = false;

			try {

				$.each(value, function (dindex, dvalue) {
					if ((dvalue == 'null') || (dvalue == null) || (dvalue.length == 0) || (dvalue.toLowerCase() == 'undefined')) {dvalue = "&nbsp;";}

					if (dvalue == '&nbsp;') {dvalue = "";}

					try {
						switch(dindex.toUpperCase()) {
							case "FLEETNEWSTITLE":
								dtitle = dvalue;
								break;
							case "FLEETNEWSBODY":
								dbody = dvalue;
								isFleet = true;
								break;
							case "NEWSTITLE":
								dtitle = dvalue;
								break;
							case "NEWSBODY":
								dbody = dvalue;
								break;
						}
					} catch(e) {}
				});
			} catch (e) {}

			if ((dtitle + dbody).length > 0) {
				if (isFleet) {
					dbody = replaceAll( Base64.decode(dbody), "\n", "<BR>")
				} else {
					dbody = Base64.decode(dbody);
				}
				if (dbody.lastIndexOf("`") >= (dbody.length - 5)) {
					dbody = dbody.substring(0, dbody.lastIndexOf("`"));
				}
				
				content_indi += '<li data-target="#headlinescarousel" data-slide-to="' + itmCnt + '"></li>';
				content_inner += '<div class="item"><div class="news-item"><h1 class="news-item__title">'
					+ Base64.decode(dtitle) + '</h1><p class="news-item__content">'
					+ dbody + '...</p></div></div>';

				itmCnt++;
				newscnt++;
			}
		});

	} catch (e) {}

	if (newscnt > 0) {
		$("#headloadinglinesholder").hide();

		$("#headlinescarousel").carousel("pause").removeData();

		$('#carouselindi').html(content_indi);
		$('#carouselitms').html(content_inner);
		$('#carouselitms .item').first().addClass('active');
		$('#carouselindi > li').first().addClass('active');
		$('#headlinescarousel').carousel({interval:10000});

		$("#headlinesholder").show();
	}

	if ((newsretry > 0) && (newscnt > 0)) {
		//Don't fetch anymore
	} else if ((newsretry >= 3) && (newscnt == 0)) {
		var storedResponse;
		storedResponse = getLocalStorage('LNews1');
		if ((typeof storedResponse === 'object') && (storedResponse !== null)) {
			$("#headloadinglinesholder").hide();

			$("#headlinescarousel").carousel("pause").removeData();
	
			$('#carouselindi').html(content_indi);
			$('#carouselitms').html(content_inner);
			$('#carouselitms .item').first().addClass('active');
			$('#carouselindi > li').first().addClass('active');
			$('#headlinescarousel').carousel({interval:10000});
	
			$("#headlinesholder").show();
		} else {
		
			$("#headlinelbl").text('No headlines available');
		
		}
	} else if (newsretry < 3) {
		newsretry++;
		if (jqVESSEL_SERVICES.length > 2) {
			if (jqVESSEL_SERVICES[1] == "1") {
				newsdate = getDateMMDDYYYY(newsDay); //"20150624";
				getLoginHeadlines(newsdate);
			}
		} else {
			newsdate = getDateMMDDYYYY(newsDay); //"20150624";
			getLoginHeadlines(newsdate);
		}
		newsDay++;
	}

	//ajxCnt--;
	//hideLoadingMessageDispIfDone();
}

function getPendingWANSet() {
	<?php
	/*if ($GLOBALS['isprod']) {
		$GLOBALS['wanconf'] = "/www/wanconf.txt";
	} else {
		$GLOBALS['wanconf'] = "../../wanconf.txt";
	}
	$f = $GLOBALS['wanconf'];*/
	$f = "../../wanconf.txt";
	$wanset = '';
	if (is_file($f)) {
		$fh = fopen($f, 'r');
		$wanset = fgets($fh);
		fclose($fh);
		
		//unlink($f);
		
		echo "console.log('File found');";
	}
	
	echo "console.log('WAN: " . $wanset . "');";
	
	if (strlen($wanset) > 0) {
	?>
	
	var wansettosave  = '<?php echo $wanset; ?>'
	
	var intermacid = "<?php echo $GLOBALS['MACID']; ?>";
				
	var noerror = true;
	var dhost = '../serv.php';
	
	var requestfleetoneconfig;
	requestfleetoneconfig = $.ajax({
		url: dhost,
		type: "post",
		data: { act: '12', macid: intermacid, wansettosave: wansettosave },
		timeout: 30000
	});

	requestfleetoneconfig.done(function (response, textStatus, jqXHR){
		if ((response == "FALSE") || (textStatus == "FALSE")) {} else {
			deleteWANTempFile();
		}
	});

	requestfleetoneconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestfleetoneconfig.always(function () {
		requestfleetoneconfig = null;
	});
	<?php } ?>
}

function deleteDNSTempFile() {
	var noerror = true;
	var dhost = '../serv.php';
	
	var requestfleetoneconfig;
	requestfleetoneconfig = $.ajax({
		url: dhost,
		type: "post",
		data: { act: '19' },
		timeout: 30000
	});

	requestfleetoneconfig.done(function (response, textStatus, jqXHR){
	});

	requestfleetoneconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestfleetoneconfig.always(function () {
		requestfleetoneconfig = null;
	});
}

function getPendingDNSSet() {
	<?php
	/*if ($GLOBALS['isprod']) {
		$GLOBALS['dnsconf'] = "/www/dnsconf.txt";
	} else {
		$GLOBALS['dnsconf'] = "../../dnsconf.txt";
	}
	$f = $GLOBALS['dnsconf'];*/
	$f = "../../dnsconf.txt";
	$dnsset = '';
	if (is_file($f)) {
		$fh = fopen($f, 'r');
		$dnsset = fgets($fh);
		fclose($fh);
		
		//unlink($GLOBALS['dnsconf']);
		
		echo "console.log('File found');";
	}
	
	echo "console.log('DNS: " . $dnsset . "');";
	
	if (strlen($dnsset) > 0) {
	?>
	
	var dnssettosave  = '<?php echo $dnsset; ?>'
	
	var intermacid = "<?php echo $GLOBALS['MACID']; ?>";
				
	var noerror = true;
	var dhost = '../serv.php';
	
	var requestfleetoneconfig;
	requestfleetoneconfig = $.ajax({
		url: dhost,
		type: "post",
		data: { act: '18', macid: intermacid, dnssettosave: dnssettosave },
		timeout: 30000
	});

	requestfleetoneconfig.done(function (response, textStatus, jqXHR){
		if ((response == "FALSE") || (textStatus == "FALSE")) {} else {
			deleteDNSTempFile();
		}
	});

	requestfleetoneconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestfleetoneconfig.always(function () {
		requestfleetoneconfig = null;
	});
		
	<?php } ?>
}

function deleteWANTempFile() {
	var noerror = true;
	var dhost = '../serv.php';
	
	var requestfleetoneconfig;
	requestfleetoneconfig = $.ajax({
		url: dhost,
		type: "post",
		data: { act: '13' },
		timeout: 30000
	});

	requestfleetoneconfig.done(function (response, textStatus, jqXHR){
	});

	requestfleetoneconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestfleetoneconfig.always(function () {
		requestfleetoneconfig = null;
	});
}

function refetchHeadlinesNUnread() {
	clearInterval( reloadHeadlinesUnread );
	
	//CHECK IF WAN SETTINGS TO FORWARD
	getPendingWANSet();
	getPendingDNSSet();
	
	<?php if ($rmt === "1") { ?>
	//getfwcpsetts();
	//getPrevDNSSet();
		/*<?php if ($isProd) { ?>
			//sendVesselVersion();
			getFleetOneSettings();
		<?php } else { ?>
			getfwcpsetts();
		<?php } ?>*/
	getFleetOneSettings();
	<?php } ?>

	getVesselSettings({macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>'<?php echo urladdparams(); ?>+""+getSession()});

	//getVesselConfig({macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>'<?php echo urladdparams(); ?>+""+getSession()});

	/*getUserUnread({macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>'<?php echo urladdparams(); ?>+""+getSession()});

	*/content_indi = "";
	content_inner = "";
	itmCnt = 0;
	newsretry = 0; newsDay = 0;
	getLoginHeadlines('1');/*

	hideLoadingMessageDispIfDone();

	reloadHeadlinesUnread = setInterval(function () {
		refetchHeadlinesNUnread();
	}, 1800000); //30 mins interval*/
	
	<?php
		if ($rmt === "1") {
			if ($isself == "login.php") {} else {
	?>
		//showLoadingMessageDisp("Synchronizing settings. Please wait.");
	<?php
			}
		} else {
			if ($isself == "login.php") {
	?>
	refetchHeadlinesNUnreadHERE();
	<?php
			}
		}
	?>
}

//var doGetHeadlines = 3;
function refetchHeadlinesNUnreadHERE() {
	//getVesselSettings({macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>'<?php echo urladdparams(); ?>+""+getSession()});

	//getVesselConfig({macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>'<?php echo urladdparams(); ?>+""+getSession()});

	//getUserUnread({macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>'<?php echo urladdparams(); ?>+""+getSession()});

	/*content_indi = "";
	content_inner = "";
	itmCnt = 0;
	newsretry = 0; newsDay = 0;
	if (doGetHeadlines >= 3) {
		getLoginHeadlines('1');
		doGetHeadlines = 0;
	}
	doGetHeadlines++;*/
	
	getUserUnread({macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>'<?php echo urladdparams(); ?>+""+getSession()});

	<?php if ($rmt === "1") { ?>
	//showLoadingMessageDisp("Synchronizing settings. Please wait.");
	<?php } else { ?>
	hideLoadingMessageDispIfDone();
	<?php } ?>

	clearInterval( reloadHeadlinesUnread ); clearInterval( tickerDisplayTimer );
	reloadHeadlinesUnread = setInterval(function () {
		//refetchHeadlinesNUnread();
		refetchHeadlinesNUnreadHERE();
		console.log('refreshed');
	}, 600000); //Set to every 10 minutes since it's only local //1800000 (30 mins interval)
}

function getfwsett() {
	var noerror = true;
	var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/rest/requestfirewallsettings';
	var act = "POST";
	
	var intermacid = "<?php echo $GLOBALS['MACID']; ?>";
	
	if (act == "POST") {
		
		var requestprevconfig;
		requestprevconfig = $.ajax({
			url: dhost,
			type: "post",
			data: { macid: intermacid },
			timeout: 30000
		});
	
		requestprevconfig.done(function (response, textStatus, jqXHR){
			if (noerror) {
				var dresponse = "";
				try {
				
					$.each(response, function (index, value) {
						
						try {
							$.each(value, function (dindex, dvalue) {
								if ((dvalue == 'null') || (dvalue == null) || (dvalue.length == 0) || (dvalue.toLowerCase() == 'undefined')) {dvalue = "";}
								
								if (dvalue == '&nbsp;') {dvalue = "";}
								try {
									switch(dindex.toLowerCase()) {
										case "vessel_portlist":
											if ((dvalue.length == 0)) {} else {
												dresponse = dvalue;
											}
											break;
									}
								} catch(e) {}
							});
						} catch (e) {}
						
					});
				
				} catch (e) {}
				
				if (dresponse.length == 0) {
				} else {
					rmFWFL = dresponse;
					var res_arr = dresponse.split("|");
					var tmp = res_arr[0];
					if (tmp.substring(tmp.length-1) == ";") {tmp = tmp.substring(0,tmp.length-1);}
					rmFW = tmp.substring(tmp.indexOf("A;")+2, tmp.length).substring(tmp.indexOf("B;")+2, tmp.length).split(";");
					//console.log(rmFW);
				}
				
				getcpsett();
			}
		});
	
		requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
			noerror = false;
			<?php if ($isself == "login.php") { ?>
			refetchHeadlinesNUnreadHERE();
			<?php } ?>
		});
	
		requestprevconfig.always(function () {
			requestprevconfig = null;
		});

	}
}

function getcpsett() {
	var noerror = true;
	var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/rest/requestcaptiveportalsettings';
	var act = "POST";
	
	var intermacid = "<?php echo $GLOBALS['MACID']; ?>";
	
	if (act == "POST") {
		
		var requestprevconfig;
		requestprevconfig = $.ajax({
			url: dhost,
			type: "post",
			data: { macid: intermacid },
			timeout: 30000
		});
	
		requestprevconfig.done(function (response, textStatus, jqXHR){
			if (noerror) {
				var dresponse = "";
				try {
				
					$.each(response, function (index, value) {
						
						try {
							try {
							$.each(value, function (dindex, dvalue) {
								if ((dvalue == 'null') || (dvalue == null) || (dvalue.length == 0) || (dvalue.toLowerCase() == 'undefined')) {dvalue = "";}
								
								if (dvalue == '&nbsp;') {dvalue = "";}
								try {
									switch(dindex.toLowerCase()) {
										case "vessel_iplist":
											if ((dvalue.length == 0)) {} else {
												dresponse = dvalue;
											}
											break;
									}
								} catch(e) {}
							});
						} catch (e) {}
						} catch (e) {}
						
					});
					
					if (dresponse.length == 0) {
					} else {
						rmCPFL = dresponse;
						var res_arr = dresponse.split("|");
						var tmp = res_arr[0];
						if (tmp.substring(tmp.length-1) == ";") {tmp = tmp.substring(0,tmp.length-1);}
						rmCP = tmp.split(";");
						//console.log(rmCP);
					}
					
					//dosetfwcpsetts();
					
					CurrentWANSets();
				
				} catch (e) {}
			}
		});
	
		requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
			noerror = false;
			<?php if ($isself == "login.php") { ?>
			refetchHeadlinesNUnreadHERE();
			<?php } ?>
		});
	
		requestprevconfig.always(function () {
			requestprevconfig = null;
			//refetchHeadlinesNUnreadHERE();
		});

	}
}

function CurrentFWSets() {
	var noerror = true;
	var dhost = '<?php echo $GLOBALS['FWURL']; ?>' + '?query';
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		timeout: 10000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			var res_arr = response.split("|");
			var tmp = res_arr[0];
			lclFWFL = response;
			if (tmp.substring(tmp.length-1) == ";") {tmp = tmp.substring(0,tmp.length-1);}
			lclFW = tmp.substring(tmp.indexOf("A;")+2, tmp.length).substring(tmp.indexOf("B;")+2, tmp.length).split(";");
			//console.log(lclFW);
			
			CurrentCPBPSets();
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		<?php if ($isself == "login.php") { ?>
		refetchHeadlinesNUnreadHERE();
		<?php } ?>
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
	
}

function CurrentCPBPSets() {
	var noerror = true;
	var dhost = '<?php echo $GLOBALS['CPBPURL']; ?>';
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		timeout: 10000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			var res_arr = response.split("|");
			var tmp = res_arr[0];
			if (tmp.substring(tmp.length-1) == ";") {tmp = tmp.substring(0,tmp.length-1);}
			lclCP = tmp.split(";");
			//console.log(lclCP);
			
			getfwsett();
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		<?php if ($isself == "login.php") { ?>
		refetchHeadlinesNUnreadHERE();
		<?php } ?>
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
		
}

function CurrentWANSets() {
	var noerror = true;
	var dhost = '<?php echo $GLOBALS['WANURL']; ?>' + '?mode=getwan';
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		data: { mode: 'getwan' },
		timeout: 10000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			processWANConf(response);
			
			CurrentWANForwardSets();
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		<?php if ($isself == "login.php") { ?>
		refetchHeadlinesNUnreadHERE();
		<?php } ?>
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
	
}

function processWANConf(response) {
	response = response.replace("</pre>", "").replace("</pre>", "").replace("<pre>", "").replace("<pre>", "");
	responseArr = response.split("\n");
	var proto = "";
	var ipaddr = "";
	var netmask = "";
	var gateway = "";
	var broadcast = "";
	var dns = "";
	
	for (var i=0; i<responseArr.length; i++) {
		if (responseArr[i].trim().toUpperCase() == "WAN SET") {
		} else if (responseArr[i].indexOf('proto') >= 0) {
			proto = responseArr[i].replace('proto','').replace("'",'').replace("'",'').trim();
		} else if (responseArr[i].indexOf('ipaddr') >= 0) {
			ipaddr = responseArr[i].replace('ipaddr','').replace("'",'').replace("'",'').trim();
		} else if (responseArr[i].indexOf('netmask') >= 0) {
			netmask = responseArr[i].replace('netmask','').replace("'",'').replace("'",'').trim();
		} else if (responseArr[i].indexOf('gateway') >= 0) {
			gateway = responseArr[i].replace('gateway','').replace("'",'').replace("'",'').trim();
		} else if (responseArr[i].indexOf('broadcast') >= 0) {	
			broadcast = responseArr[i].replace('broadcast','').replace("'",'').replace("'",'').trim();
		} else if (responseArr[i].indexOf('dns') >= 0) {	
			dns = responseArr[i].replace('dns','').replace("'",'').replace("'",'').trim();
		} 
	}
	
	if (proto == 'dhcp') {
		lclWAN = "dhcp<>";
	} else {
		lclWAN = "static<" + ipaddr + ";" + netmask + ";" +  gateway + ";" +  broadcast + ";" +  dns + ">";
	}
}

function CurrentWANForwardSets() {
	var noerror = true;
	var dhost = '<?php echo $GLOBALS['WANURL']; ?>' + '?mode=getforward';
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		data: { mode: 'getforward' },
		timeout: 10000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			processWANForwardConf(response);
			
			getwansettRETRIEVE();
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		<?php if ($isself == "login.php") { ?>
		refetchHeadlinesNUnreadHERE();
		<?php } ?>
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
	
}

function processWANForwardConf(response) {
	response = response.replace("</pre>", "").replace("</pre>", "").replace("<pre>", "").replace("<pre>", "");
	responseArr = response.split("\n");
	
	var forwardCnt = (response.match(new RegExp("name", "g")) || []).length;
	
	var proto = "";
	var src_port = "";
	var dest_port = "";
	var dest_ip = "";
	var name = "";
	arrForwards = [];
	
	if (forwardCnt == 0) {} else {
		var cnt = 0; var prevcnt = 0; arrRet = null;
		for (var i=0; i<responseArr.length; i++) {
			if (responseArr[i].toUpperCase().trim() == "FORWARD SET") {
			} else if (responseArr[i].indexOf('proto') >= 0) {	
				proto = responseArr[i].replace('proto','').replace("'",'').replace("'",'').trim();
			} else if (responseArr[i].indexOf('src_port') >= 0) {	
				src_port = responseArr[i].replace('src_port','').replace("'",'').replace("'",'').trim();
			} else if (responseArr[i].indexOf('src_dport') >= 0) {	
				src_port = responseArr[i].replace('src_dport','').replace("'",'').replace("'",'').trim();
			} else if (responseArr[i].indexOf('dest_port') >= 0) {	
				dest_port = responseArr[i].replace('dest_port','').replace("'",'').replace("'",'').trim();
			} else if (responseArr[i].indexOf('dest_ip') >= 0) {	
				dest_ip = responseArr[i].replace('dest_ip','').replace("'",'').replace("'",'').trim();
			} else if (responseArr[i].indexOf('name') >= 0) {	
				name = responseArr[i].replace('name','').replace("'",'').replace("'",'').trim();
				cnt++;
			}
			
			if (prevcnt !=cnt) {
				lclWAN = lclWAN + "|" + name + ";" + proto + ";" + src_port + ";" + dest_port + ";" + dest_ip;
				arrForwards.push(name);
				
				prevcnt = cnt;
			}
		}
	}
}

function getwansettRETRIEVE() {
	var noerror = true;
	var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/rest/requestwansettings';
	var act = "POST";
	
	var intermacid = "<?php echo $GLOBALS['MACID']; ?>";
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "post",
		data: {macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>'<?php echo urladdparams(); ?>+""+getSession()},
		timeout: 30000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			var dresponse = "";
			try {
			
				$.each(response, function (index, value) {
					
					try {
						$.each(value, function (dindex, dvalue) {
							if ((dvalue == 'null') || (dvalue == null) || (dvalue.length == 0) || (dvalue.toLowerCase() == 'undefined')) {dvalue = "";}
							
							if (dvalue == '&nbsp;') {dvalue = "";}
							try {
								switch(dindex.toLowerCase()) {
									case "vessel_wanportlist":
										if ((dvalue.length == 0)) {} else {
											dresponse = dvalue;
										}
										break;
								}
							} catch(e) {}
						});
					} catch (e) {}
					
				});
			
			} catch (e) {}
			
			rmWAN = dresponse;
			if (rmWAN.length == 0) {rmWAN = lclWAN;} //"dhcp<>"
			console.log(rmWAN);
			
			//console.log((lclWAN == rmWAN)?"SAME":"CHANGED");
			//if (lclWAN == rmWAN) {} else {saveWANConf(rmWAN)};
			
			//dosetfwcpsetts();
			//getPrevDNSSet(false);
			getPrevDNSReso(false);
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
		<?php if ($isself == "login.php") { ?>
		refetchHeadlinesNUnreadHERE();
		<?php } ?>
	});
}

function saveWANConf(response) {
	if (response.length > 0) {
		var listArr = response.split("|");
		
		var modeArr = listArr[0].split("<");
		if (modeArr[0].toLowerCase() == 'dhcp') {
			setWANInterface('dhcp', '', '', '', '', '');
		} else {
			var staticArr = modeArr[1].replace(">", "").split(";");
			
			if ((staticArr[0].length > 0) && (staticArr[1].length > 0) && (staticArr[2].length > 0) && (staticArr[3].length > 0) && (staticArr[4].length > 0)) {
				setWANInterface('static', staticArr[0], staticArr[1], staticArr[2], staticArr[3], staticArr[4]);
			} else {
				setWANInterface('dhcp', '', '', '', '', '');
			}
		}
		
		//DELETE FORWARDERS FIRST
		for (var i=0; i<arrForwards.length; i++) {
			delForwardInterface(arrForwards[i]);
		}
		
		if ((listArr.length > 1) && (listArr[1].length > 0)) {
			for (var ii=1; ii<listArr.length; ii++) {
				var forwardsArr = listArr[ii].split("|");
				for (var i=0; i<forwardsArr.length; i++) {
					var forwardInfoArr = forwardsArr[i].split(";");
					if ((forwardInfoArr[0].length > 0) && (forwardInfoArr[1].length > 0) && (forwardInfoArr[2].length > 0) && (forwardInfoArr[3].length > 0) && (forwardInfoArr[4].length > 0)) {
						setForwardInterface(forwardInfoArr[1], forwardInfoArr[2], forwardInfoArr[3], forwardInfoArr[4], forwardInfoArr[0]);
					}
				}
			}
		}
	}
}

function setWANInterface(proto, ipaddr, netmask, gateway, broadcast, dns) {
	console.log("Set WAN " + proto);
	
	var noerror = true;
	var dhost;
	var requestprevconfig;
	
	if (proto == 'dhcp') {
		dhost = '<?php echo $GLOBALS['WANURL']; ?>' + '?mode=setwan&proto='+proto;
		requestprevconfig = $.ajax({
			url: dhost,
			type: "get",
			data: { mode: 'setwan', proto: proto },
			timeout: 10000
		});
	} else {
		dhost = '<?php echo $GLOBALS['WANURL']; ?>' + '?mode=setwan&proto='+proto+'&ipaddr='+ipaddr+'&netmask='+netmask+'&gateway='+gateway+'&broadcast='+broadcast+'&dns='+dns;
		requestprevconfig = $.ajax({
			url: dhost,
			type: "get",
			data: { mode: 'setwan', proto: proto, ipaddr: ipaddr, netmask: netmask, gateway: gateway, broadcast: broadcast, dns: dns },
			timeout: 10000
		});
	}

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			console.log(response);
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
}

function setForwardInterface(proto, src_port, dest_port, dest_ip, name) {
	console.log("Set forward " + name);
	
	var noerror = true;
	var dhost = '<?php echo $GLOBALS['WANURL']; ?>' + '?mode=setforward&proto='+proto+'&src_port='+src_port+'&dest_port='+dest_port+'&dest_ip='+dest_ip+'&name='+name;
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		data: { mode: 'setforward', proto: proto, src_port: src_port, dest_port: dest_port, dest_ip: dest_ip, name: name },
		timeout: 10000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			console.log(response);
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
}

function delForwardInterface(name) {
	console.log("Delete forward " + name);
	
	var noerror = true;
	var dhost = '<?php echo $GLOBALS['WANURL']; ?>' + '?mode=delforward&name='+name;
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		data: { mode: 'delforward', name: name },
		timeout: 10000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			console.log(response);
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
}

function getfwcpsetts() {
	//CurrentFWSets();
	
	getRemoteDNXnProxy();
	
	/*CurrentCPBPSets();
	getfwsett();
	getcpsett();*/
}

<?php
	if ($isProd) {
		$GLOBALS['dnxlist'] = "/www/dnx.txt";
	} else {
		$GLOBALS['dnxlist'] = "../../mailparser/production/serverfiles/dnx.txt";
	}

	function getPrevProxy() {
		$ret = "";
		
		$durl = "http://" . (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']) . "/cgi-bin/proxy?GET_PROXY";
		$postData = array('GET_PROXY' => "");
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($postData)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			$response = str_replace("<pre>", "", $response);
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("'", "", $response);
			$response = str_replace("'", "", $response);
			$ret = $response;
		}
		
		return $ret;
	}
	
	function getPrevDNS() {
		$ret = "";
		
		$durl = "http://" . (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']) . "/cgi-bin/autodns?GET_DNS1";
		$postData = array('GET_DNS1' => "");
		$context = stream_context_create(array(
			'http' => array(
				'header'  => "Content-Type: application/x-www-form-urlencoded",
				'method'  => 'GET',
				'content' => http_build_query($postData)
			)
		));
		
		$response = file_get_contents($durl, false, $context);
		if ($response === FALSE){
		} else {
			$response = str_replace("<pre>", "", $response);
			$response = str_replace("</pre>", "", $response);
			$response = str_replace("'", "", $response);
			$response = str_replace("'", "", $response);
			$ret = $response;
		}
		
		return $ret;
	}
	
	function getDNXProxy() {
		$iniFile = $GLOBALS['dnxlist'];
		if (is_file($iniFile)) {
			//Do nothing... File already exists
		} else {
			//Try to create
			$fh = fopen($iniFile, 'w+');
			fclose($fh);
		}
		$filecontent = file_get_contents($iniFile);
		
		if (strlen($filecontent) == 0) {
			$filecontent = "NX=203.99.233.69|proxy1=93.157.3.169|user1=rick|pass1=kbs-720x|port1=12025|proxy2=|user2=|pass2=|port2=";
		}
		
		return $filecontent;
	}
?>

var currProxy = '<?php echo getPrevProxy(); ?>';
var phost1 = "";
var phost1u = "";
var phost1p = "";
var phost1port = "";
var phost2 = "";
var phost2u = "";
var phost2p = "";
var phost2port = "";

var currProxyArr = currProxy.split(',');
for (var i = 0; i < currProxyArr.length; i++){
	var currProt = currProxyArr[i].split('=');
	switch(currProt[0]) {
		case "proxy1":
			phost1 = currProt[1];
			break;
		case "user1":
			phost1u = currProt[1];
			break;
		case "pass1":
			phost1p = currProt[1];
			break;
		case "password1":
			phost1p = currProt[1];
			break;
		case "port1":
			phost1port = currProt[1];
			break;
		case "proxy2":
			phost2 = currProt[1];
			break;
		case "user2":
			phost2u = currProt[1];
			break;
		case "pass2":
			phost2p = currProt[1];
			break;
		case "password2":
			phost2p = currProt[1];
			break;
		case "port2":
			phost2port = currProt[1];
			break;
	}
}

var currDNSIP = '<?php echo getPrevDNS(); ?>';
var DNXProxy = '<?php echo getDNXProxy(); ?>';
var dnxDNS = "";
var dnxDNS1 = "";
var dnxDNS2 = "";
var dnxphost1 = "";
var dnxphost1u = "";
var dnxphost1p = "";
var dnxphost1port = "";
var dnxphost2 = "";
var dnxphost2u = "";
var dnxphost2p = "";
var dnxphost2port = "";
var currProxyArr = DNXProxy.split('|');
for (var i = 0; i < currProxyArr.length; i++){
	var currProt = currProxyArr[i].split('=');
	switch(currProt[0]) {
		case "NX":
			dnxDNS = currProt[1];
			break;
		case "proxy1":
			dnxphost1 = currProt[1];
			break;
		case "user1":
			dnxphost1u = currProt[1];
			break;
		case "pass1":
			dnxphost1p = currProt[1];
			break;
		case "password1":
			dnxphost1p = currProt[1];
			break;
		case "port1":
			dnxphost1port = currProt[1];
			break;
		case "proxy2":
			dnxphost2 = currProt[1];
			break;
		case "user2":
			dnxphost2u = currProt[1];
			break;
		case "pass2":
			dnxphost2p = currProt[1];
			break;
		case "password2":
			dnxphost2p = currProt[1];
			break;
		case "port2":
			dnxphost2port = currProt[1];
			break;
	}
}

var dnxDNSArr = dnxDNS.split(",");
for (var i = 0; i < dnxDNSArr.length; i++){
	switch(i) {
		case 0:
			dnxDNS1 = dnxDNSArr[i];
			break;
		case 1:
			dnxDNS2 = dnxDNSArr[i];
			break;
	}
}

var remotednxDNS = "";
var remotednxDNS1 = "";
var remotednxDNS2 = "";
var remotednxphost1 = "";
var remotednxphost1u = "";
var remotednxphost1p = "";
var remotednxphost1port = "";
var remotednxphost2 = "";
var remotednxphost2u = "";
var remotednxphost2p = "";
var remotednxphost2port = "";

if (dnxphost1.length <= 0) {dnxphost1=phost1;}
if (dnxphost1u.length <= 0) {dnxphost1u=phost1u;}
if (dnxphost1p.length <= 0) {dnxphost1p=phost1p;}
if (dnxphost1port.length <= 0) {dnxphost1port=phost1port;}
if (dnxphost2.length <= 0) {dnxphost2=phost2;}
if (dnxphost2u.length <= 0) {dnxphost2u=phost2u;}
if (dnxphost2p.length <= 0) {dnxphost2p=phost2p;}
if (dnxphost2port.length <= 0) {dnxphost2port=phost2port;}

function getRemoteDNXnProxy() {
	var noerror = true;
	
	if (currDNSIP == dnxDNS1) {
		console.log("NX! Get new settings.");
		
		var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/lib/ssapi.php';
		
		var requestremotednxnproxy;
		requestremotednxnproxy = $.ajax({
			url: dhost,
			type: "post",
			data: { act: 1 },
			timeout: 30000
		});
	
		requestremotednxnproxy.done(function (response, textStatus, jqXHR){
			if (noerror) {
				var responseArr = response.split('[DEL]');
				for (var i = 0; i < responseArr.length; i++){
					if (i == 0) {
					} else if (i == 1) {
						
						var currProxyArr = responseArr[i].split('|');
						for (var i = 0; i < currProxyArr.length; i++){
							var currProt = currProxyArr[i].split('=');
							switch(currProt[0]) {
								case "NX":
									remotednxDNS = currProt[1];
									break;
								case "proxy1":
									remotednxphost1 = currProt[1];
									break;
								case "user1":
									remotednxphost1u = currProt[1];
									break;
								case "pass1":
									remotednxphost1p = currProt[1];
									break;
								case "password1":
									remotednxphost1p = currProt[1];
									break;
								case "port1":
									remotednxphost1port = currProt[1];
									break;
								case "proxy2":
									remotednxphost2 = currProt[1];
									break;
								case "user2":
									remotednxphost2u = currProt[1];
									break;
								case "pass2":
									remotednxphost2p = currProt[1];
									break;
								case "password2":
									remotednxphost2p = currProt[1];
									break;
								case "port2":
									remotednxphost2port = currProt[1];
									break;
							}
						}
						
						var dnxDNSArr = remotednxDNS.split(",");
						for (var i = 0; i < dnxDNSArr.length; i++){
							switch(i) {
								case 0:
									remotednxDNS1 = dnxDNSArr[i];
									break;
								case 1:
									remotednxDNS2 = dnxDNSArr[i];
									break;
							}
						}
						
						if (remotednxphost1.length <= 0) {remotednxphost1=phost1;}
						if (remotednxphost1u.length <= 0) {remotednxphost1u=phost1u;}
						if (remotednxphost1p.length <= 0) {remotednxphost1p=phost1p;}
						if (remotednxphost1port.length <= 0) {remotednxphost1port=phost1port;}
						if (remotednxphost2.length <= 0) {remotednxphost2=phost2;}
						if (remotednxphost2u.length <= 0) {remotednxphost2u=phost2u;}
						if (remotednxphost2p.length <= 0) {remotednxphost2p=phost2p;}
						if (remotednxphost2port.length <= 0) {remotednxphost2port=phost2port;}

					}
					
				}
			}
		});
	
		requestremotednxnproxy.fail(function (jqXHR, textStatus, errorThrown){
			noerror = false;
		});
	
		requestremotednxnproxy.always(function () {
			requestremotednxnproxy = null;
			
			CurrentFWSets();
			//getFleetOneSettings();
		});
	
	} else {
		CurrentFWSets();
		//getFleetOneSettings();
	}
}

<?php
if ($isProd) {
	$GLOBALS['dashservhost'] = "../serv.php";
} else {
	$GLOBALS['dashservhost'] = "../../mailparser/production/serverfiles/management/serv.php";
}
?>

function getFleetOneSettings() {
	var noerror = true;
	var dhost = '<?php echo $GLOBALS['dashservhost']; ?>';
	
	var requestfleetoneconfig;
	requestfleetoneconfig = $.ajax({
		url: dhost,
		type: "get",
		data: { act: '8' },
		timeout: 30000
	});

	requestfleetoneconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			console.log(response);
		}
	});

	requestfleetoneconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestfleetoneconfig.always(function () {
		requestfleetoneconfig = null;
		
		getVesselSettings({macid: '<?php echo $GLOBALS['MACID']; ?>', api_key: '<?php echo $GLOBALS['APIKEY']; ?>'<?php echo urladdparams(); ?>+""+getSession()});
		
		<?php
		if ($isself == "login.php") {} else {
			$mOrD = "m"; $toDir = "";
			if (isset($GLOBALS['ISDESKTOP']) && $GLOBALS['ISDESKTOP'] == "1") {
				$mOrD = "d"; $toDir = "../m/";
			}
		?>
			if (top == self) {
				setTimeout(function () {
					if ((jqVESSEL_REGSTATUS == 1) || (jqVESSEL_REGSTATUS == "1")) {
					} else {
						try {
							showLoadingMessageDisp('Logging off... Please wait.');$(window).unbind('beforeunload');
						} catch (e) {}
						try {
							window.location.href = "<?php echo $toDir; ?>serv.php?act=0&dir=<?php echo $mOrD; ?>";
						} catch (e) {}
						
					}
					
				}, 2000);
			}
		<?php	
		}
		?>
		
		//CurrentFWSets();
		//sendVesselVersion();
		
		<?php if ($isProd) { ?>
			sendVesselVersion();
		<?php } else { ?>
			getfwcpsetts();
		<?php } ?>
	});
}

var callDNXFileUpdate = false;
function updateDNXnProxyFiles(doReboot) {
	var noerror = true; callDNXFileUpdate = true;
	
	var dhost = '<?php echo $GLOBALS['dashservhost']; ?>'; 
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		data: { act: '14' },
		timeout: 30000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			if (doReboot) {
				didARequestReboot = true;
				rebootTerminal();
				showMessageAlert('Remote settings update was successfully applied to the router.\n\nThe router is rebooting, please wait a couple of minutes.');
			}
		}
		callDNXFileUpdate = false;
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		
		if (doReboot) {
			didARequestReboot = true;
			rebootTerminal();
			showMessageAlert('Remote settings update was successfully applied to the router.\n\nThe router is rebooting, please wait a couple of minutes.');
		}
		callDNXFileUpdate = false;
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
}

function rebootTerminal() {
	var noerror = true;
	var dhost = '<?php echo $GLOBALS['dashservhost']; ?>';
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		data: { act: '11' },
		timeout: 30000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			try {
			
			} catch (e) {}
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		//alert(textStatus);
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
}

var dnsSet = []; var dnsBlkSet = [];
var domainsToProcess = []; var domainsToProcessAct = []; var processCnt = 0;

<?php
	if ($isProd) {
		$GLOBALS['fwloc'] = "/etc/firmwareversion";
	} else {
		$GLOBALS['fwloc'] = "../firmwareversion";
	}
	function getFWVersion() {
		$iniFile = $GLOBALS['fwloc'];
		if (is_file($iniFile)) {
			//Do nothing... File already exists
		} else {
			//Try to create
			$fh = fopen($iniFile, 'w+');
			fclose($fh);
		}
		$filecontent = file_get_contents($iniFile);
		$filecontent = trim($filecontent);
		
		if (strlen($filecontent) == 0) {
			$filecontent = "Unknown";
		}
		
		return $filecontent;
	}
?>
function sendVesselVersion() {
	var cui = '<?php echo trim(trim(trim($out[1]))); ?>';
	var fwver = '<?php echo trim(trim(trim(getFWVersion()))); ?>';
	var kernelver = '<?php echo trim(trim(trim(shell_exec('uname -a')))); ?>';
	var chilliver = '<?php echo trim(trim(trim(shell_exec('chilli -V')))); ?>';
	var intermacid = "<?php echo $GLOBALS['MACID']; ?>";
	
	var noerror = true;
	var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'apidev/rest/saveversioninfo';
	
	var requestapi;
	requestapi = $.ajax({
		url: dhost,
		type: "post",
		data: { macid: intermacid,
				fwver: fwver,
				uiver: cui,
				kernelver: kernelver,
				coovaver: chilliver
			},
		timeout: 30000
	});
	
	requestapi.done(function (response, textStatus, jqXHR){
		if (noerror) {
		}
	});

	requestapi.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
	});

	requestapi.always(function () {
		requestapi = null;
		
		getfwcpsetts();
	});
}

function getPrevDNSReso(doSave) {
	var noerror = true;
		
	var dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?read_dnsfilter';
	
	var requestsavefwconfig;
	requestsavefwconfig = $.ajax({
		url: dhost,
		type: "get",
		timeout: 10000
	});

	requestsavefwconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			if (response.trim().length > 0) {
				processDNSReso(response, doSave);
			}
		}
	});

	requestsavefwconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		
		dnsSet[0] = "B";
		getPrevDNSSet(doSave);
	});

	requestsavefwconfig.always(function () {
		requestsavefwconfig = null;
	});
}

function processDNSReso(response, doSave) {
	dnsSet = []; var cnt = 0;
	
	response = response.replace("</pre>", "").replace("</pre>", "").replace("<pre>", "").replace("<pre>", "");
	response = response.trim().trim().trim();
	if (response.length == 0) {response = "";}
	responseArr = response.split("\n");
	for (var i=0; i<1/*responseArr.length*/; i++) {
		if (responseArr[i].trim().length > 0) {
			dnsSet[cnt] = responseArr[i].trim();
			cnt++;
		}
	}
	
	getPrevDNSSet(doSave);
}

function getPrevDNSSet(doSave) {
	var noerror = true;
		
	var dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?whitelist_read';
	
	var requestsavefwconfig;
	requestsavefwconfig = $.ajax({
		url: dhost,
		type: "get",
		timeout: 10000
	});

	requestsavefwconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			if (response.trim().length > 0) {
				processDNSSet(response, doSave);
			} else {
				dosetfwcpsetts();
			}
		}
	});

	requestsavefwconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		
		$("#loading").fadeOut(500);
		$("#loadingmsgholder").fadeOut(500);
		
		alert('Error fetching remote settings. Please try again.');
	});

	requestsavefwconfig.always(function () {
		requestsavefwconfig = null;
	});
}

function processDNSSet(response, doSave) {
	/*dnsSet = [];*/ var cnt = 1;
	
	response = response.replace("</pre>", "").replace("</pre>", "").replace("<pre>", "").replace("<pre>", "");
	response = response.trim().trim().trim();
	if (response.length == 0) {response = "";}
	responseArr = response.split("\n");
	for (var i=0; i<responseArr.length; i++) {
		if (responseArr[i].trim().length > 0) {
			dnsSet[cnt] = responseArr[i].trim();
			cnt++;
		}
	}
	
	//getDNSFilterShore();
	getPrevBlkDNSSetforRemote(doSave);
}

function getPrevBlkDNSSetforRemote(doSave) {
	var noerror = true;
		
	var dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?blacklist_read';
	
	var requestsavefwconfig;
	requestsavefwconfig = $.ajax({
		url: dhost,
		type: "get",
		timeout: 10000
	});

	requestsavefwconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			if (response.trim().length > 0) {
				processBlkDNSSetforRemote(response, doSave);
			} else {
				getDNSFilterShore();
			}
		}
	});

	requestsavefwconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		
		$("#loading").fadeOut(500);
		$("#loadingmsgholder").fadeOut(500);
		
		alert('Error fetching remote settings. Please try again.');
	});

	requestsavefwconfig.always(function () {
		requestsavefwconfig = null;
	});
}

function processBlkDNSSetforRemote(response, doSave) {
	dnsBlkSet = []; var cnt = 0;
	
	response = response.replace("</pre>", "").replace("</pre>", "").replace("<pre>", "").replace("<pre>", "");
	response = response.trim().trim().trim();
	if (response.length == 0) {response = "";}
	responseArr = response.split("\n");
	for (var i=0; i<responseArr.length; i++) {
		if (responseArr[i].trim().length > 0) {
			dnsBlkSet[cnt] = responseArr[i].trim();
			cnt++;
		}
	}
	
	getDNSFilterShore();
}

function processDNSRemote(response) {
	domainsToProcess = [];
	domainsToProcessAct = [];

	var responseArr = response.split('[DEL]');
	var addAllowBlock = false; var allowBlockAct = "";
	try {
		if (responseArr[2].trim().length > 0) {
			var arr = responseArr[2].split(",");
			var tmpd = "";
			for (var i=1; i<dnsSet.length; i++) {
				var seen = false;
				tmpd = dnsSet[i].trim();
				if (tmpd.length > 0) {
					for (var ii=1; ii<arr.length; ii++) {
						if (tmpd == arr[ii]) {
							seen = true;
						}
					}
				}
				
				if (seen == false) {
					//DELETE
					//console.log("Delete: " + tmpd);
					domainsToProcess[processCnt] = tmpd;
					domainsToProcessAct[processCnt] = 'DEL';
					processCnt++;
				}
			}
			
			tmpd = "";
			for (var i=1; i<arr.length; i++) {
				var seen = false;
				tmpd = arr[i].trim();
				if (tmpd.length > 0) {
					for (var ii=1; ii<dnsSet.length; ii++) {
						if (tmpd == dnsSet[ii]) {
							seen = true;
						}
					}
				}
				
				if (seen == false) {
					//console.log("Add: " + tmpd);
					domainsToProcess[processCnt] = tmpd;
					domainsToProcessAct[processCnt] = 'ADD';
					processCnt++;
				}
			}
			
			if (arr[0] == dnsSet[0]) {} else {
				addAllowBlock = true;
				allowBlockAct = arr[0];
			}
		}
	} catch (e) {}
	
	try {
		//if (responseArr[3].trim().replace('[DNSBLK]', "").length > 0) {
			var arr = responseArr[3].replace('[DNSBLK]', "").split(",");
			var tmpd = "";
			for (var i=0; i<dnsBlkSet.length; i++) {
				var seen = false;
				tmpd = dnsBlkSet[i].trim();
				if (tmpd.length > 0) {
					for (var ii=0; ii<arr.length; ii++) {
						if (tmpd == arr[ii]) {
							seen = true;
						}
					}
				}
				
				if (seen == false) {
					//DELETE
					//console.log("Delete: " + tmpd);
					domainsToProcess[processCnt] = tmpd;
					domainsToProcessAct[processCnt] = 'DELBLK';
					processCnt++;
				}
			}
			
			tmpd = "";
			for (var i=0; i<arr.length; i++) {
				var seen = false;
				tmpd = arr[i].trim();
				if (tmpd.length > 0) {
					for (var ii=0; ii<dnsBlkSet.length; ii++) {
						if (tmpd == dnsBlkSet[ii]) {
							seen = true;
						}
					}
				}
				
				if (seen == false) {
					//console.log("Add: " + tmpd);
					domainsToProcess[processCnt] = tmpd;
					domainsToProcessAct[processCnt] = 'ADDBLK';
					processCnt++;
				}
			}
		//}
	} catch (e) {}
	
	if (addAllowBlock) {
		domainsToProcess[processCnt] = allowBlockAct;
		domainsToProcessAct[processCnt] = 'ALLOWBLOCK';
		processCnt++;
	}
			
	if (domainsToProcess.length > 0) {
		domainsToProcess[processCnt] = "RELOAD";
		domainsToProcessAct[processCnt] = 'RELOAD';
		processCnt++;
		
		domainsToProcess[processCnt] = "UPDATE";
		domainsToProcessAct[processCnt] = 'UPDATE';
		processCnt++;
	}
	
	if (domainsToProcess.length > 0) {
		saveDNS(0);
	} else {
		dosetfwcpsetts();
	}
}

function getDNSFilterShore() {
	var noerror = true;
	var dhost = host.replace('[CHANGEIP]', checkServerConnection()) + 'api/lib/ssapi.php';console.log(dhost);
	var intermacid = "<?php echo $GLOBALS['MACID']; ?>";
		
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "post",
		data: { act: 2, macid: intermacid },
		timeout: 30000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			
			if (response.length > 0) {
				processDNSRemote(response);
			} else {
				dosetfwcpsetts();
			}
		}
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		
		$("#loading").fadeOut(500);
		$("#loadingmsgholder").fadeOut(500);
		
		alert('Error fetching remote settings. Please try again.');
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
}

function saveDNS(indx) {
	var noerror = true;
	
	try {
		
		if (domainsToProcess[indx].length > 0) {
		
			var dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?whitelist_allow=' + domainsToProcess[indx];
			if (domainsToProcessAct[indx] == "DEL") {
				dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?whitelist_remove=' + domainsToProcess[indx];
				requestReboot = true;
			} else if (domainsToProcessAct[indx] == "RELOAD") {
				dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?reload';
			} else if (domainsToProcessAct[indx] == "ALLOWBLOCK") {
				dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?setallowblock=' + domainsToProcess[indx];
				requestReboot = true;
			}
			
			 else if (domainsToProcessAct[indx] == "ADDBLK") {
				dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?blacklist_allow=' + domainsToProcess[indx];
				requestReboot = true;
			} else if (domainsToProcessAct[indx] == "DELBLK") {
				dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?blacklist_remove=' + domainsToProcess[indx];
				requestReboot = true;
			} else if (domainsToProcessAct[indx] == "UPDATE") {
				dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/dnsfilter?dnsfilter_update';
			} else {
				requestReboot = true;
			}
			
			var requestsavefwconfig;
			requestsavefwconfig = $.ajax({
				url: dhost,
				type: "get",
				timeout: 10000
			});
		
			requestsavefwconfig.done(function (response, textStatus, jqXHR){
				if (noerror) {
					indx++;
					if (domainsToProcess.length > indx) {
						saveDNS(indx);
					} else {
						dosetfwcpsetts();
					}
				}
			});
		
			requestsavefwconfig.fail(function (jqXHR, textStatus, errorThrown){
				noerror = false;
			});
		
			requestsavefwconfig.always(function () {
				requestsavefwconfig = null;
			});
		
		} else {
			indx++;
			if (domainsToProcess.length > indx) {
				saveDNS(indx);
			} else {
				dosetfwcpsetts();
			}
		}
	
	} catch (e) {
		indx++;
		if (domainsToProcess.length > indx) {
			saveDNS(indx);
		} else {
			dosetfwcpsetts();
		}
	}
}

var proxUpdating = false; var dnsUpdating = false; var callFuncWithReboot = false; var rebootPending; var sleepSaveFWCPSetts;
function dosetfwcpsetts() {
	var nodnsChange = true; var noproxy1Change = true; var noproxy2Change = true;
	//Check if DNS is the same, if not, apply new DNS
	if (currDNSIP == dnxDNS1) {
		if (currDNSIP != remotednxDNS) {
			//APPLY NEW DNS
			nodnsChange = false;
		}
		
		//Check if same proxy 1
		if (remotednxphost1.length > 0) {
			if ((phost1 == remotednxphost1) && (phost1u == remotednxphost1u) && (phost1p == remotednxphost1p) && (phost1port == remotednxphost1port)) {
			} else {
				//APPLY NEW proxy
				noproxy1Change = false;
			}
		}
		if (remotednxphost2.length > 0) {
			if ((phost2 == remotednxphost2) && (phost2u == remotednxphost2u) && (phost2p == remotednxphost2p) && (phost2port == remotednxphost2port)) {
			} else {
				//APPLY NEW proxy
				noproxy2Change = false;
			}
		}
	}
	
	if (doArrCompare(lclFW, rmFW) && doArrCompare(lclCP, rmCP) && (lclWAN == rmWAN) && (lclFWFL == rmFWFL) && nodnsChange && noproxy1Change && noproxy2Change) {
		console.log('No Changes!');
		updateDNXnProxyFiles(false);
		
		if ((didARequestReboot == false) && requestReboot) {
			rebootTerminal();
			showMessageAlert('Remote settings update was successfully applied to the router.\n\nThe router is rebooting, please wait a couple of minutes.');
		}
		
		//hideLoadingMessageDisp();
	} else {
		var dnxproxupdatecall = false;
		//SEND NEW SETTINGS TO LINKSYS!!!
		if (doArrCompare(lclFW, rmFW) && doArrCompare(lclCP, rmCP) && (lclFWFL == rmFWFL)) {
				
			if (nodnsChange) {} else {
				applyDNSIP('MANUAL3', remotednxDNS1, remotednxDNS2);
			}
			if ((noproxy1Change == false) || (noproxy2Change == false)) {
				applyProxy();
			}
			//if ((nodnsChange == false) || (noproxy1Change == false) || (noproxy2Change == false)) {
				if (lclWAN == rmWAN) {
					updateDNXnProxyFiles(true);
				} else {
					updateDNXnProxyFiles(false);
				}
			//}
			
			if (!(lclWAN == rmWAN)) {
				callFuncWithReboot = true;
				
				saveWANConf(rmWAN);
				//saveFWCPSetts();
				
				clearInterval( sleepSaveFWCPSetts );
				sleepSaveFWCPSetts = setInterval(function () {
					if (callDNXFileUpdate) {} else {
						clearInterval( sleepSaveFWCPSetts );
						saveFWCPSetts();
					}
				}, 1000);
			}
		} else
		//if ((rmFWFL.length() > 0) && (rmCPFL.length() > 0)) {
		if ((rmFWFL.length > 0) || (rmCPFL.length > 0)) {
			if (nodnsChange) {} else {
				applyDNSIP('MANUAL3', remotednxDNS1, remotednxDNS2);
			}
			if ((noproxy1Change == false) || (noproxy2Change == false)) {
				applyProxy();
			}
			if ((nodnsChange == false) || (noproxy1Change == false) || (noproxy2Change == false)) {
				updateDNXnProxyFiles(false); dnxproxupdatecall = true;
			}
			
			callFuncWithReboot = true;
			
			saveWANConf(rmWAN);
			while(dnsUpdating) {console.log('updating...');}
			
			//saveFWCPSetts();
			clearInterval( sleepSaveFWCPSetts );
			sleepSaveFWCPSetts = setInterval(function () {
				if (callDNXFileUpdate) {} else {
					clearInterval( sleepSaveFWCPSetts );
					saveFWCPSetts();
				}
			}, 1000);
		} else if ((nodnsChange == false) || (noproxy1Change == false) || (noproxy2Change == false)) {
			if (nodnsChange) {} else {
				applyDNSIP('MANUAL3', remotednxDNS1, remotednxDNS2);
			}
			if ((noproxy1Change == false) || (noproxy2Change == false)) {
				applyProxy();
			}
			updateDNXnProxyFiles(true); dnxproxupdatecall = true;
			
			if (!(lclWAN == rmWAN)) {
				callFuncWithReboot = true;
				
				saveWANConf(rmWAN);
				//saveFWCPSetts();
				clearInterval( sleepSaveFWCPSetts );
				sleepSaveFWCPSetts = setInterval(function () {
					if (callDNXFileUpdate) {} else {
						clearInterval( sleepSaveFWCPSetts );
						saveFWCPSetts();
					}
				}, 1000);
			}
			
			if (lclWAN == rmWAN) {
				updateDNXnProxyFiles(true); dnxproxupdatecall = true;
			} else {
				updateDNXnProxyFiles(false); dnxproxupdatecall = false;
				callFuncWithReboot = true;
				
				saveWANConf(rmWAN);
				//saveFWCPSetts();
				clearInterval( sleepSaveFWCPSetts );
				sleepSaveFWCPSetts = setInterval(function () {
					if (callDNXFileUpdate) {} else {
						clearInterval( sleepSaveFWCPSetts );
						saveFWCPSetts();
					}
				}, 1000);
			}
		}
		if (dnxproxupdatecall == false) {
			updateDNXnProxyFiles(false);
		}
		
		/*if ((didARequestReboot == false) && requestReboot) {
			rebootTerminal();
			showMessageAlert('Remote settings update was successfully applied to the router.\n\nThe router is rebooting, please wait a couple of minutes.');
		}*/
		
		if (callFuncWithReboot) {
				
			clearInterval( rebootPending );
			rebootPending = setInterval(function () {
				if (callFuncWithReboot) {} else {
					if ((didARequestReboot == false) && requestReboot) {
						clearInterval( rebootPending );
						rebootTerminal();
						console.log('4');
						alert('Remote settings update was successfully applied to the router.\n\nThe router is rebooting, please wait a couple of minutes.');
					}
				}
				
				//hideLoadingMessageDisp();
			}, 1000);
			
		} else {
			
			setTimeout(function () {
				if ((didARequestReboot == false) && requestReboot) {
					rebootTerminal();
					console.log('3');
					alert('Remote settings update was successfully applied to the router.\n\nThe router is rebooting, please wait a couple of minutes.');
				}
				
				//hideLoadingMessageDisp();
			}, 1000);
			
		}
	}
}

function applyProxy() {
	proxUpdating = true;
	
	var fact = 'proxy?SET_PROXY&proxy1='+remotednxphost1+'&user1='+remotednxphost1u+'&pass1='+remotednxphost1p+'&port1='+remotednxphost1port+'&proxy2='+remotednxphost2+'&user2='+remotednxphost2u+'&pass2='+remotednxphost2p+'&port2='+remotednxphost2port;
	var noerror = true;
	var dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/' + fact;
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		timeout: 30000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			
		}
		proxUpdating = false;
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		proxUpdating = false;
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
}

function applyDNSIP(act, dnsip, dnsip2) {
	dnsUpdating = true;
	
	var setDNS = "SET_DNS1";
	var fact = 'autodns?SET_DNS1=AUTO';
	if (act == "MANUAL3") {
		fact = "autodns?SET_DNS1=" + dnsip;
	} else if (act == "MANUAL") {
		fact = "autodns?SET_DNS1=" + dnsip;
	} else if (act == "MANUAL2") {
		fact = "autodns?SET_DNS2=" + dnsip;
		setDNS = "SET_DNS2";
	}
	var noerror = true;
	var dhost = 'http://<?php echo (($_SERVER['SERVER_ADDR'] == "::1")?"192.168.32.1":$_SERVER['SERVER_ADDR']); ?>/cgi-bin/' + fact;
	
	var requestprevconfig;
	requestprevconfig = $.ajax({
		url: dhost,
		type: "get",
		//data: { setDNS: dnsip },
		timeout: 30000
	});

	requestprevconfig.done(function (response, textStatus, jqXHR){
		if (noerror) {
			
		}
		dnsUpdating = false;
	});

	requestprevconfig.fail(function (jqXHR, textStatus, errorThrown){
		noerror = false;
		dnsUpdating = false;
	});

	requestprevconfig.always(function () {
		requestprevconfig = null;
	});
}

function doArrCompare(arr1, arr2) {
	Array.prototype.equals = function (array, strict) {
		if (!array)
			return false;
	
		if (arguments.length == 1)
			strict = true;
	
		if (this.length != array.length)
			return false;
	
		for (var i = 0; i < this.length; i++) {
			if (this[i] instanceof Array && array[i] instanceof Array) {
				if (!this[i].equals(array[i], strict))
					return false;
			}
			else if (strict && this[i] != array[i]) {
				return false;
			}
			else if (!strict) {
				return this.sort().equals(array.sort(), true);
			}
		}
		return true;
	};
	
	/*var arr1 = [1, 2, 3, 4];
	var arr2 = [2, 1, 4, 3];
	var arr3 = [2, 2, 3, 4];
	var arr4 = [1, 2, 3, 4];
	
	document.getElementById("test_1e2_strict").innerHTML = arr1.equals(arr2);
	document.getElementById("test_1e2_loose").innerHTML = arr1.equals(arr2, false);
	document.getElementById("test_1e3_strict").innerHTML = arr1.equals(arr3);
	document.getElementById("test_1e3_loose").innerHTML = arr1.equals(arr3, false);
	document.getElementById("test_1e4_strict").innerHTML = arr1.equals(arr4);
	document.getElementById("test_1e4_loose").innerHTML = arr1.equals(arr4, false);*/
	
	return arr1.equals(arr2, false);
}

function saveFWCPSetts() {
	if (rmFWFL.length > 0) {
	
		isRemoteUpdating = true;
		var noerror = true;
		
		var dhost = '<?php echo $GLOBALS['FWURL']; ?>' + '?filter=' + rmFWFL;
		
		var requestsavefwconfig;
		requestsavefwconfig = $.ajax({
			url: dhost,
			type: "post",
			data: { filter: rmFWFL },
			timeout: 10000
		});
	
		requestsavefwconfig.done(function (response, textStatus, jqXHR){
			if (noerror) {
				saveCPBPConfLocal();
			}
		});
	
		requestsavefwconfig.fail(function (jqXHR, textStatus, errorThrown){
			noerror = false;
			isRemoteUpdating = false;
		});
	
		requestsavefwconfig.always(function () {
			requestsavefwconfig = null;
		});
	
	} else {
		saveCPBPConfLocal();
	}
}

function saveCPBPConfLocal() {
	if (rmCPFL.length > 0) {
		
		var noerror = true;
			
		var dhost = '<?php echo $GLOBALS['CPBPURL']; ?>' + '?set=' + rmCPFL;
		
		var requestsavefwconfig;
		requestsavefwconfig = $.ajax({
			url: dhost,
			type: "post",
			data: { set: rmCPFL },
			timeout: 10000
		});
	
		requestsavefwconfig.done(function (response, textStatus, jqXHR){
			if (noerror) {
				didARequestReboot = true;
				showMessageAlert('Remote settings update was successfully applied to the router.\n\nThe router is rebooting, please wait a couple of minutes.');
				isRemoteUpdating = false;
			}
		});
	
		requestsavefwconfig.fail(function (jqXHR, textStatus, errorThrown){
			noerror = false;
			isRemoteUpdating = false;
		});
	
		requestsavefwconfig.always(function () {
			requestsavefwconfig = null;
		});
		
	}
}

	<?php
	if ($isself == "login.php") {
	} else {
		$mOrD = "m"; $toDir = "";
		if (isset($GLOBALS['ISDESKTOP']) && $GLOBALS['ISDESKTOP'] == "1") {
			$mOrD = "d"; $toDir = "../m/";
		}
	?>
		$(document).ready(function () {
			if (top == self) {
				setTimeout(function () {
					if ((jqVESSEL_REGSTATUS == 1) || (jqVESSEL_REGSTATUS == "1")) {
					} else {
						try {
							showLoadingMessageDisp('Logging off... Please wait.');$(window).unbind('beforeunload');
						} catch (e) {}
						try {
							window.location.href = "<?php echo $toDir; ?>serv.php?act=0&dir=<?php echo $mOrD; ?>";
						} catch (e) {}
					}
					
				}, 2000);
			}
		});
	<?php	
	}
	?>
</script>
